//+------------------------------------------------------------------+
//|                                         Pivot Moving Average.mq4 |
//|                                                             Pooh |
//|                                                               NA |
//+------------------------------------------------------------------+
#property copyright "Pooh"
#property link      "NA"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Orange


//--- input parameters

extern int       Period_1=20;
extern int       Count=100;
extern int       MA_Period;
extern bool      Sample=false;




//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel(0,"Ocean Number");     //for bottom divergence
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexLabel(1,"Upper Band");      //for top divergence
  
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexLabel(2,"Lower Band");
   
   string short_name = "Ocean";
IndicatorShortName(short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int    counted_bars=IndicatorCounted();
   int Period_H;
   
//----
    if(counted_bars<0) return(-1);
  
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
  
     for(int i=0; i<limit; i++)
      {
       for(int j=1;j<=Period_1;j++)
       {
        if(iClose(NULL,0,j+i)==iClose(NULL,0,iHighest(NULL,0,Period_1,i)))
        {
        Period_H=j;
        break;
        }
        continue;
       }
      
        ExtMapBuffer1[i]=(MathLog(iClose(NULL,0,i))-MathLog(iClose(NULL,0,i+Period_1)))/MathSqrt(Period_1);
     }
       
       
       
       for(i=0;i<limit;i++)
       {
        
        ExtMapBuffer2[i]=iDeviation(ExtMapBuffer1[i],MA_Period,Sample,i);
        
           
       }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+


double workDev[];
double iDeviation(double value, int length, bool isSample, int i)
{
   if (ArraySize(workDev)!=Bars) ArrayResize(workDev,Bars); i=Bars-i-1; 
                 workDev[i] = value;
                 double sumx=0,sumxx=0; for (int k=0; k<length && k<=i; sumx+=workDev[i-k],sumxx+=workDev[i-k]*workDev[i-k],k++) {}
   return(MathSqrt((sumxx-sumx*sumx/length)/MathMax(length-isSample,1)));
}